 
  
enum YN
{
   Yes = 1,
   No = 0
};
 

//+------------------------------------------------------------------+
//|Basic parameters
//+------------------------------------------------------------------+

#include <stdlib.mqh>
 
input int      MagicNumber                    = 123456; 
input double   LotSize                        = 1.0;  
input double   TakeProfit                     = 1000;
input double   StopLoss                       = 500;

input double   MaxSpread                      = 1000;
input double   Slippage                       = 500;

input double   MaxTrades                      = 10;

input ENUM_TIMEFRAMES 
               TimeFrame1              = PERIOD_H4,
               TimeFrame2              = PERIOD_H1,
               TimeFrame3              = PERIOD_M30;
               

input YN       StopLossManagerOn             = No;

input double   StopLossAfterGain1            = 0.0;
input double   StopLossLevel1                = 0.0;

input double   StopLossAfterGain2            = 0.0;
input double   StopLossLevel2                = 0.0;

input double   StopLossAfterGain3            = 0.0;
input double   StopLossLevel3                = 0.0;

input double   StopLossAfterGain4            = 0.0;
input double   StopLossLevel4                = 0.0;
 
input  YN   TradingEntryTime                 = Yes; 
int         GMTOffsetOfBroker                = 0;
input int   TimezoneStartHour                = 0,
            TimezoneStartMinute              = 0,
            TimezoneEndHour                  = 16,
            TimezoneEndMinute                = 30; 
            
void OnDeinit(const int reason)
{

}
void OnInit()
{

}
datetime signalCheck;
int lastCross = 0;
void OnTick(void)
{ 
   double macdTF1 =  iOsMA(NULL,TimeFrame1,12,26,9,PRICE_CLOSE,1);
   double macdTF2 =  iOsMA(NULL,TimeFrame2,12,26,9,PRICE_CLOSE,1);
   
   double pmacdTF3 =  iOsMA(NULL,TimeFrame3,12,26,9,PRICE_CLOSE,2);
   double macdTF3 =  iOsMA(Symbol(),TimeFrame3,12,26,9,PRICE_CLOSE,1);
   
   // Print(NormalizeDouble(iOsMA(Symbol(),0,12,26,9,PRICE_CLOSE,1),10));
   
  
   
   double psma3 = iMA(NULL,TimeFrame3,3,0,MODE_SMA,PRICE_CLOSE,2);
   double sma3 = iMA(NULL,TimeFrame3,3,0,MODE_SMA,PRICE_CLOSE,1); 

   double psma5 = iMA(NULL,TimeFrame3,5,0,MODE_SMA,PRICE_CLOSE,2);
   double sma5 = iMA(NULL,TimeFrame3,5,0,MODE_SMA,PRICE_CLOSE,1); 

   //+------------------------------------------------------------------+
   //|ORDER MANAGEMENT                                                  |
   //+------------------------------------------------------------------+
   
   int oc = countOrders(-1);
   
   if(oc>0)
      manageRealStopLoss();
    
   if(iTime(NULL,TimeFrame3,0)!=signalCheck)
   {
      if(pmacdTF3<=0 && macdTF3>=0)
      {
        // Print ("C U "+macdTF3+" "+TimeToStr(Time[1]));
         lastCross = 1;
      }
      else if(pmacdTF3>=0 && macdTF3<=0)
      {
         //Print ("C D "+macdTF3+" "+TimeToStr(Time[1]));
         lastCross = -1;
      }
      
      bool cleared = false;
      if(psma3 >= psma5 && sma3 <= sma5)
      {
         cleared = true;
         clearTradingQueue(OP_BUY);
      }
      else if(psma3 <= psma5 && sma3 >= sma5)
      {
         cleared = true;
         clearTradingQueue(OP_SELL);
      }   
      
       
      
      if(countOrdersHPa() < MaxTrades)
      {
         //Print(macdTF1+" "+macdTF2+" "+macdTF3);
         if(macdTF1 > 0 && macdTF2 > 0 && macdTF3 >= 0 && psma3 <= psma5 && sma3 >= sma5 && lastCross == 1)
         { 
            openOrder(LotSize,MagicNumber,OP_BUY,Ask-StopLoss*Point,Ask+TakeProfit*Point);
            lastCross = 0;
         }
         else if(macdTF1 < 0 && macdTF2 < 0 && macdTF3 <= 0 && psma3 >= psma5 && sma3 <= sma5 && lastCross == -1)
         {
            openOrder(LotSize,MagicNumber,OP_SELL,Bid+StopLoss*Point,Bid-TakeProfit*Point);
            lastCross = 0;
         }
      }
      signalCheck = iTime(NULL,TimeFrame3,0);
   }
    
     
   //+------------------------------------------------------------------+
   //|DISPLAY 
   //+------------------------------------------------------------------+
   
   loglabel("--------------------------------------","L4", 10,30,Gold);
   loglabel("HPa OSMA EA  2015","L5", 10,50,Gold);
   loglabel("--------------------------------------","L7", 10,70,Gold);
    
   
}

//+------------------------------------------------------------------+
//|TOOL FUNCTIONS 
//+------------------------------------------------------------------+
bool openOrder(double _lots,int _magic,int _type,double __sl,double __tp, string _description = "HPa" )
{ 
   if(!tradeTime())return(0);
   
   if(MathAbs(MarketInfo(Symbol(),MODE_ASK) - MarketInfo(Symbol(),MODE_BID)) > MaxSpread)
   {
      Print("Spread limit exceeded, trade rejected");
      return(0);
   }
   
   while(IsTradeContextBusy())Sleep(1000);
   if(!IsTradeAllowed())
	{
	   Print("TRADE NOT ALLOWED IN PROPERTIES");  
		return (0);
	}
   
	int error = 0;
	int ticket = 0;
         
   RefreshRates();
   
   int repeat = 0;      
   
   while(true)
   {      
      while(IsTradeContextBusy())Sleep(1000);      
      RefreshRates();
      
      switch(_type)
      {
         case OP_SELL: 
         {
             ticket = OrderSend(Symbol(),OP_SELL,_lots,MarketInfo(Symbol(),MODE_BID),0,0,0, _description,_magic,0,Red);
         }
         break;
         case OP_BUY: 
         {
             ticket = OrderSend(Symbol(),OP_BUY,_lots,MarketInfo(Symbol(),MODE_ASK),0,0,0, _description,_magic,0,Green);
         }
         break;
      }
      
      repeat++;
      
      if(repeat>60)
      {
         Print("ORDER SEND FAILED IN 60 ATTEMPTS");
         break;
      }   

      if(ticket>0)
         break;
   
      if(!IsTradeAllowed())
   	{
   		Sleep(1000);
   		continue; 
   	}
      Print("Failed to send order retry: "+IntegerToString(repeat));
      Print("ERROR DESCRIPTION: "+ErrorDescription(GetLastError()));         
      
      Sleep(1000);/*przy niepowodzeniu odczekaj sekund i ponw*/   
   }


   if(ticket<=0)
   {
      error=GetLastError();
      Print("FINAL SEND ORDER ERROR:", ErrorDescription(error));
   }
   else
   { 
      if(__tp>0)
         moveExitLevel(ticket,__tp,1);
         
      if(__sl>0)
         moveExitLevel(ticket,__sl,-1);
         
         return(1);
   }
 
   return (0);
}    

void clearTradingQueue(int type)
{
   //close all
   int oc = countOrders(type);
   while(oc > 0)
   { 
      RefreshRates();
      for(int cnt = 0 ;cnt<OrdersTotal();cnt++)
      {
        if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
        if(OrderMagicNumber() == MagicNumber) 
        {
            if(OrderType() == OP_BUY && (OP_BUY == type || type == -1))
            {
               if(!OrderClose(OrderTicket(),OrderLots(), Bid, 0, Yellow))continue;
            }
            else if(OrderType() == OP_SELL && (OP_SELL == type || type == -1))
            {
               if(!OrderClose(OrderTicket(),OrderLots(), Ask, 0, Yellow))continue;
            }
        } 
      }
      oc = countOrders(type); 
   }
}   
void loglabel(string text,string name, int x,int y,color Color = White, string font = "Times New Roman")
{
   if(StringLen(text)>0)
   {
   if(ObjectFind(name)!=-1)ObjectDelete(name);
   
   ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(name,text, 11, font, Color);
   ObjectSet(name, OBJPROP_CORNER, 4);
   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);
    
    
   }
}
  
int countOrders(int type)
{
    
    int oc = 0;
    for(int cnt = 0 ;cnt<OrdersTotal();cnt++)
    {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
      if(OrderMagicNumber() == MagicNumber && (OrderType() == type || type == -1)) 
      oc+=1;
    } 
    return(oc);
}

int countOrdersHPa()
{
    
    int oc = 0;
    for(int cnt = 0 ;cnt<OrdersTotal();cnt++)
    {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
      if(OrderComment() == "HPa") 
      oc+=1;
    } 
    return(oc);
}
 
   
bool moveExitLevel(int ticket,double newValue,int type,int _sleep = 1/*in seconds*/,int _retries = 5)
{
   //type 1= takeprofit, type =-1 stoploss
   if(!IsTradeAllowed()) return (0);
   
   if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
   {
      Print("ERROR : order "+((string)ticket)+" not found");
      return(0);
   }
   string _orderSymbol = OrderSymbol();
   
   int error;
   int MAXRETRIES = _retries;
   int retries = 0;
   
   if(type == -1)
   {
      if(MathAbs(MarketInfo(_orderSymbol,MODE_ASK)-newValue)/MarketInfo(_orderSymbol,MODE_POINT) < MarketInfo(_orderSymbol,MODE_STOPLEVEL)) 
      {
         Print("Stoploss too close");
         return(0);
      }
      
      while(!OrderModify(ticket,OrderOpenPrice(), newValue, OrderTakeProfit(), 0,CLR_NONE))
      {
         error = GetLastError();
         if(error>1) Print("MoveSL failed with error #",error," CurrentSL ",OrderStopLoss()," NewSL ",newValue);
         Sleep(_sleep*1000);
         if(retries >= MAXRETRIES) 
         return(0);
         else
         retries++;
         RefreshRates();
      }
   }
   else if(type == 1)
   {
      if(MathAbs(MarketInfo(_orderSymbol,MODE_BID)-newValue)/MarketInfo(_orderSymbol,MODE_POINT) < MarketInfo(_orderSymbol,MODE_STOPLEVEL)) 
      {
         Print("Takeprofit too close");
         return(0);
      }
      while(!OrderModify(ticket,OrderOpenPrice(), OrderStopLoss(), newValue, 0,CLR_NONE))
      {
         error = GetLastError();
         if(error>1) Print("MoveTP failed with error #",error," CurrentTP ",OrderTakeProfit()," NewTP ",newValue);
         Sleep(_sleep*1000);
         if(retries >= MAXRETRIES) 
         return(0);
         else
         retries++;
         RefreshRates();
      }
   }
   return(1);
} 

void manageRealStopLoss()
{
   if(StopLossManagerOn == No)return;
    
    
      while(true)
      {
         int closed = 0;
         for(int cnt = 0 ;cnt < OrdersTotal();cnt++)
         {
            if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
            if(OrderMagicNumber() == MagicNumber)
            {  
               if(StopLossManagerOn == Yes)
               {
                  double   currentSl   = NormalizeDouble(OrderStopLoss(),Digits);
                  int      ticket      = OrderTicket();
                  
                  if(OrderType() == OP_BUY)
                  {			
                     if(
                        (
                           currentSl == 0 || 
                           currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel1*Point,Digits)  
                        )
                        && High[1] >= (OrderOpenPrice()+StopLossAfterGain1*Point)
                        && StopLossAfterGain1 > 0.0)
                     {
                         if(currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel1*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()+StopLossLevel1*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                         }
                     }
                     
                     if(
                        (
                        currentSl == 0 || 
                        currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel2*Point,Digits)  
                        )
                        && High[1] >= (OrderOpenPrice()+StopLossAfterGain2*Point)
                        && StopLossAfterGain2 > 0.0)
                     {
                         if(currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel2*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()+StopLossLevel2*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                        }
                     }
                     
                     if(
                        (
                        currentSl == 0 || 
                        currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel3*Point,Digits)  
                        )
                        && High[1] >= (OrderOpenPrice()+StopLossAfterGain3*Point)
                        && StopLossAfterGain3 > 0.0)
                     {
                         if(currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel3*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()+StopLossLevel3*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                                                 
                         }
                     }
                     
                      if(
                        (
                        currentSl == 0 || 
                        currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel4*Point,Digits)  
                        )
                        && High[1] >= (OrderOpenPrice()+StopLossAfterGain4*Point)
                        && StopLossAfterGain4 > 0.0)
                     {
                         if(currentSl < NormalizeDouble(OrderOpenPrice()+StopLossLevel4*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()+StopLossLevel4*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                                                 
                         }
                     }
                  }
                  else if(OrderType() == OP_SELL)
                  {
                     if(
                        (
                        currentSl == 0 || 
                        currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel1*Point,Digits)
                        ) 
                        && Low[1] <= (OrderOpenPrice()-StopLossAfterGain1*Point)
                        && StopLossAfterGain1 > 0.0)
                     {
                         if(currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel1*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()-StopLossLevel1*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                                           
                         }
                     }
                     
                     if(
                        (
                        currentSl == 0 || 
                        currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel2*Point,Digits)
                        ) 
                        && Low[1] <= (OrderOpenPrice()-StopLossAfterGain2*Point)
                        && StopLossAfterGain2 > 0.0)
                     {
                         if(currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel2*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()-StopLossLevel2*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                                      
                         }
                     }
                     
                     if(
                        (
                        currentSl == 0 || 
                        currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel3*Point,Digits)
                        ) 
                        && Low[1] <= (OrderOpenPrice()-StopLossAfterGain3*Point)
                        && StopLossAfterGain3 > 0.0)
                     {
                         if(currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel3*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()-StopLossLevel3*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                         }   
                     }
                     
                      if(
                        (
                        currentSl == 0 || 
                        currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel4*Point,Digits)
                        ) 
                        && Low[1] <= (OrderOpenPrice()-StopLossAfterGain4*Point)
                        && StopLossAfterGain4 > 0.0)
                     {
                         if(currentSl > NormalizeDouble(OrderOpenPrice()-StopLossLevel4*Point,Digits))
                         {  
                              currentSl = NormalizeDouble(OrderOpenPrice()-StopLossLevel4*Point,Digits);    
                              moveExitLevel(ticket,currentSl,-1);
                         }   
                     }
                  } 
               }
            }
         }         
         if(closed == 0)break;
      }
} 
 
bool tradeTime()
{  
   if(TradingEntryTime == No) return(true);
    
   bool result = false;
   
   
   datetime SessionStart = StrToTime((string)TimezoneStartHour+":"+ (string)TimezoneStartMinute);
   datetime SessionEnd   = StrToTime((string)TimezoneEndHour+":"+(string)TimezoneEndMinute);
   
   datetime ctime = TimeCurrent()-((60*60)*GMTOffsetOfBroker);
   
   if ( TimezoneStartHour <  TimezoneEndHour)
   result = ctime >= SessionStart && ctime < SessionEnd;      
   else
   if ( TimezoneStartHour >  TimezoneEndHour)
   result = (ctime > SessionStart && TimeHour(ctime) < 24)
          ||(TimeHour(ctime) >= 0 && ctime < SessionEnd);
   
   return(result);
} 